/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ComponentModelFilter.h
*
*	Description -	
*
*	Comments	-	
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	06/04/2013	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_COMPONENT_MODEL_FILTER_H_
#define _PSX_COMPONENT_MODEL_FILTER_H_

#include "PulseSTD.h"
#include "IComponent.h"

namespace Pulse
{
	class ComponentModelFilter : public IComponent
	{
	public:

		ComponentModelFilter( Actor *pOwner );

		virtual ~ComponentModelFilter( void );

		virtual EErrorCode::Type Initialize( XMLElementPtr pElem );

		virtual const EComponent::Type GetType( void ) const { return EComponent::MODEL_FILTER; }

		static const EComponent::Type GetType_Static( void ) { return EComponent::MODEL_FILTER; }

		virtual const CHAR * GetName( void ) const { return PSX_String("Model Filter"); }

		//virtual void Update( FLOAT dt ) { }

		EErrorCode::Type LoadModel( const CHAR *pFilename );

		Model * GetModel( void );

	private:

		// Delegates
	
	private:

		void ReleaseModel( void );

	private:

		Model *m_pModel;

	};
}

#endif /* _PSX_COMPONENT_MODEL_FILTER_H_ */