/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ComponentWorldStreamer.h
*
*	Description -	Main component for handling streaming of world sectors.
*
*	Comments	-
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	03/16/2013	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_COMPONENT_WORLD_STREAMER_H_
#define _PSX_COMPONENT_WORLD_STREAMER_H_

#include "PulseSTD.h"
#include "IComponent.h"

namespace Pulse
{
	class ComponentWorldStreamer : public IComponent
	{
	public:

		ComponentWorldStreamer( Actor *pOwner );

		virtual ~ComponentWorldStreamer( void );

		virtual EErrorCode::Type Initialize( XMLElementPtr pElem );

		virtual EErrorCode::Type PostInitialize( void );

		virtual const EComponent::Type GetType( void ) const { return EComponent::WORLD_STREAMER; }

		virtual const CHAR * GetName( void ) const { return PSX_String( "World Streamer" ); }
	};
}

#endif /* _PSX_COMPONENT_WORLD_STREAMER_H_ */