/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ComputeShaderStage.h
*
*	Description -	Compute shader stage
*
*	Comments	-	
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	07/23/2013	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_COMPUTE_SHADER_STAGE_H_
#define _PSX_COMPUTE_SHADER_STAGE_H_

#include "PulseSTD.h"
#include "GraphicsInfrastructure.h"
#include "IShaderStage.h"

namespace Pulse
{
	class ComputeShaderStage : public IShaderStage
	{
	public:

		ComputeShaderStage( void );

		virtual ~ComputeShaderStage( void );

		virtual EPipelineStage::Type GetType( void ) { return EPipelineStage::ComputeShader; }

		virtual void ClearStates( void );
		virtual void BindStates( void );

		virtual void BindShader( void );
		virtual void BindConstantBuffers( void );
		virtual void BindSamplerStates( void );
		virtual void BindShaderResourceViews( void );
		virtual void BindUnordererdAccessViews( void );
	};
}

#endif /* _PSX_COMPUTE_SHADER_STAGE_H_ */