/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ConstantBuffer.h
*
*	Description -	
*
*	Comments	-	
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	11/24/2011	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_CONSTANT_BUFFER_H_
#define _PSX_CONSTANT_BUFFER_H_

#include "PulseSTD.h"
#include "GraphicsTypes.h"
#include "ShaderResource.h"
#include "GraphicsBuffer.h"
#include "ResourcePoolItem.h"

namespace Pulse
{
	struct ConstantBufferDesc : public BaseResDesc
	{
		ConstantBufferDesc( void );

		void SetAsDynamicConstantBuffer( SIZE_T _bufferSize );

		void SetAsStaticConstantBuffer( SIZE_T _bufferSize, void *pInitialData );

		virtual const ResourceCode GetType( void ) const { return ResourceCode( EResource::VIDEO, EVideoResource::CONSTANT_BUFFER); }

		SIZE_T				bufferSize;
		EBufferUsage::Type	bufferUsage;
		void				*pData;
	};

	class ConstantBuffer : public IResourcePoolItem, /*public ShaderResource,*/ public GraphicsBuffer
	{
	public:

		virtual ~ConstantBuffer( void );

		// These defines the base interface for all derived resources
		virtual BOOL CreateResource( BaseResDesc *pDesc );
		virtual BOOL DestroyResource( void );
		virtual BOOL LoadResource( void );
		virtual BOOL UnloadResource( void );

		virtual const ResourceCode GetType( void ) const { return ResourceCode( EResource::VIDEO, EVideoResource::CONSTANT_BUFFER); }

	public:

	private:

		ConstantBuffer( void );

		EErrorCode::Type Initialize( void );

		void Cleanup( void );

	private:

		PSX_MakeStoragePoolFriend( ConstantBuffer );

		ConstantBufferDesc	m_desc;
	};
}

#endif /* _PSX_CONSTANT_BUFFER_H_ */