/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	EventModelLoaded.h
*
*	Description -	New model loaded in ComponentModelFilter
*
*	Comments	-
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	06/04/2013	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_EVENT_MODEL_LOADED_H_
#define _PSX_EVENT_MODEL_LOADED_H_

#include "PulseSTD.h"
#include "IEvent.h"

namespace Pulse
{
	class EventModelLoaded : public IEvent
	{
	public:

		EventModelLoaded( void );

		virtual ~EventModelLoaded( void );

		virtual const EEvent::Type GetEventType( void ) const { return EEvent::MODEL_LOADED; }

		void SetModel( Model *pModel );

		// NOTE: Increments the reference of the model
		Model * GetModel( void );	

		void ReleaseModel( void );

	public:

		Model *m_pModel;

	};
}

#endif /* _PSX_EVENT_MODEL_LOADED_H_ */
