/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	EventRender.h
*
*	Description -	Render
*
*	Comments	-
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	10/17/2012	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_EVENT_RENDER_H_
#define _PSX_EVENT_RENDER_H_

#include "PulseSTD.h"
#include "IEvent.h"
#include "RenderView.h"

namespace Pulse
{
	class EventRender : public IEvent
	{
	public:

		EventRender( void );

		virtual ~EventRender( void ) { }

		virtual const EEvent::Type GetEventType( void ) const { return EEvent::RENDER; }

		//void SetActor

		void SetCamera( ComponentCamera *pCamera ) { m_pCamera = pCamera; }

		ComponentCamera * GetCamera( void ) { return m_pCamera; }

		void SetRenderView( RenderView *pRenderView ) { m_pView = pRenderView; }

		RenderView * GetRenderView( void ) { return m_pView; }

		void SetScene( Scene *pScene ) { m_pScene = pScene; }

		Scene * GetScene( void );

	public:

		ComponentCamera	*m_pCamera;
		RenderView		*m_pView;
		Scene			*m_pScene;

	};
}

#endif /* _PSX_EVENT_RENDER_H_ */
