/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	GeometryGenerator.h
*
*	Description -	Utility class for generating common geometries.
*
*	Comments	-	
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	01/08/2013	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_GEOMETRY_GENERATOR_H_
#define _PSX_GEOMETRY_GENERATOR_H_

#include "PulseSTD.h"
#include "Vector3.h"
#include "Vector2.h"
#include "Array.h"

namespace Pulse
{
	class GeometryGenerator
	{
	public:

		

	public:

		static Geometry * CreateSphere( FLOAT radius, UINT sliceCount, UINT stackCount, const CHAR *pName = PSX_NULL );

		static Geometry * CreateFullscreenQuad( const CHAR *pName = PSX_NULL );
	};
}

#endif /* _PSX_GEOMETRY_GENERATOR_H_ */