/**************************************************************************************
*
*	Copyright (C) 2010 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ISystem.h
*
*	Description -	Abstract Interface class for systems/managers containing static
*						Initialize() and Shutdown() functions.
*
*	Comments	-	
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	02/12/2010	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_INTERFACE_SYSTEM_H_
#define _PSX_INTERFACE_SYSTEM_H_

#include "PulseSTD.h"

namespace Pulse
{
	class ISystem
	{
	public:

		virtual EErrorCode::Type Initialize( void ) = 0;

		virtual void Shutdown( void ) = 0;
		
	};
}

#endif /* _PSX_INTERFACE_SYSTEM_H_ */