/**************************************************************************************
*
*	Copyright (C) 2010 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	MaterialElementEntry.h
*
*	Description -	Struct to hold material element entry from material files.
*
*	Comments	-	All material element entries are assumed user sources. So we don't
*					need a source type.
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	09/29/2012	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_MATERIAL_ELEMENT_ENTRY_H_
#define _PSX_MATERIAL_ELEMENT_ENTRY_H_

#include "PulseSTD.h"
#include "GraphicsTypes.h"
#include "String.h"

namespace Pulse
{
	struct MaterialElementEntry
	{
		EParameter::Type	m_type;
		String					m_name;
		
		// NOTE: The data of this variable is determined based on the 
		//	type of this entry. The table provided gives m_valueString its
		//	meaning based on its type.
		//	Type	|	Meaning
		// Texture		filename
		// 
		String					m_valueString;
	};
}

#endif /* _PSX_MATERIAL_ELEMENT_ENTRY_H_ */