/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ParameterBinderConstantBuffer.h
*
*	Description -	.
*
*	Comments	-
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	10/15/2012	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_PARAMETER_BINDER_CONSTANT_BUFFER_H_
#define _PSX_PARAMETER_BINDER_CONSTANT_BUFFER_H_

#include "PulseSTD.h"
#include "GraphicsTypes.h"
#include "IParameterBinder.h"

namespace Pulse
{
	class ParameterBinderConstantBuffer : public IParameterBinder
	{
	public:

		ParameterBinderConstantBuffer( void );

		ParameterBinderConstantBuffer( IParameter *pParam );

		virtual ~ParameterBinderConstantBuffer( void );

		virtual void SetAsConstantBuffer( ConstantBuffer *pBuffer ) { SetData( pBuffer ); }

		void SetData( ConstantBuffer *pBuffer );

		virtual void BindValue( void );

		virtual EParameter::Type GetType( void ) { return EParameter::CONSTANT_BUFFER; }

	private:

		ConstantBuffer *m_pBuffer;
	};
}

#endif /* _PSX_PARAMETER_BINDER_CONSTANT_BUFFER_H_ */