/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ParameterBinderMatrixRef.h
*
*	Description -	.
*
*	Comments	-
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	02/08/2013	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_PARAMETER_BINDER_MATRIX_REF_H_
#define _PSX_PARAMETER_BINDER_MATRIX_REF_H_

#include "PulseSTD.h"
#include "GraphicsTypes.h"
#include "IParameterBinder.h"
#include "Matrix4x4.h"

namespace Pulse
{
	class ParameterBinderMatrixRef : public IParameterBinder
	{
	public:

		ParameterBinderMatrixRef( void );

		ParameterBinderMatrixRef( IParameter *pParam );

		virtual ~ParameterBinderMatrixRef( void ) { }

		virtual void SetAsMatrix( const Matrix4x4 *pData ) { SetData( pData ); }

		void SetData( const Matrix4x4 *pData ) { m_pData = pData; }

		virtual void BindValue( void );

		virtual EParameter::Type GetType( void ) { return EParameter::MATRIX; }

	private:

		const Matrix4x4 *m_pData;

	};
}

#endif /* _PSX_PARAMETER_BINDER_MATRIX_H_ */