/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ParameterBinderSamplerState.h
*
*	Description -	.
*
*	Comments	-
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	10/15/2012	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_PARAMETER_BINDER_SAMPLER_STATE_H_
#define _PSX_PARAMETER_BINDER_SAMPLER_STATE_H_

#include "PulseSTD.h"
#include "GraphicsTypes.h"
#include "IParameterBinder.h"

namespace Pulse
{
	class ParameterBinderSamplerState : public IParameterBinder
	{
	public:

		ParameterBinderSamplerState( void );

		ParameterBinderSamplerState( IParameter *pParam );

		virtual ~ParameterBinderSamplerState( void );

		virtual void SetAsSamplerState( SamplerState *pState ) { SetData( pState ); }

		void SetData( SamplerState *pBuffer );

		virtual void BindValue( void );

		virtual EParameter::Type GetType( void ) { return EParameter::SAMPLER; }

	private:

		SamplerState *m_pState;
	};
}

#endif /* _PSX_PARAMETER_BINDER_SAMPLER_STATE_H_ */