/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ParameterBinderVector4.h
*
*	Description -	.
*
*	Comments	-
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	06/10/2012	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_PARAMETER_BINDER_VECTOR_4_H_
#define _PSX_PARAMETER_BINDER_VECTOR_4_H_

#include "PulseSTD.h"
#include "GraphicsTypes.h"
#include "IParameterBinder.h"
#include "Vector4.h"

namespace Pulse
{
	class ParameterBinderVector4 : public IParameterBinder
	{
	public:

		ParameterBinderVector4( void );

		ParameterBinderVector4( IParameter *pParam );

		virtual ~ParameterBinderVector4( void ) { }

		virtual void SetAsVector4( const Vector4 *pData ) { SetData(pData); }

		void SetData( const Vector4 *pData ) { m_data = *pData; }

		virtual void BindValue( void );

		virtual EParameter::Type GetType( void ) { return EParameter::VECTOR4; }

	private:

		Vector4 m_data;

	};
}

#endif /* _PSX_PARAMETER_BINDER_VECTOR_4_H_ */