/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ParameterStructuredBuffer.h
*
*	Description -	Structured buffer parameter.
*
*	Comments	-
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	07/23/2013	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_PARAMETER_STRUCTURED_BUFFER_H_
#define _PSX_PARAMETER_STRUCTURED_BUFFER_H_

#include "PulseSTD.h"
#include "IParameter.h"
#include "StructuredBuffer.h"

namespace Pulse
{
	class ParameterStructuredBuffer : public IParameter
	{
	public:

		ParameterStructuredBuffer( void ) : m_pBuffer( PSX_NULL ) { }

		ParameterStructuredBuffer( ParameterStructuredBuffer &rhs );

		virtual ~ParameterStructuredBuffer( void );

		virtual void SetData( void *pData );

		virtual void SetData( IParameter *pParam );

		StructuredBuffer * GetStructuredBuffer( void ) { return m_pBuffer; }

		virtual EParameter::Type GetType( void ) const { return EParameter::CONSTANT_BUFFER; }

	private:

		StructuredBuffer *m_pBuffer;
	};
}

#endif /* _PSX_PARAMETER_STRUCTURED_BUFFER_H_ */