/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ParameterVector3.h
*
*	Description -	A vector render parameter.
*
*	Comments	-
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	06/30/2012	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_PARAMETER_VECTOR_3_H_
#define _PSX_PARAMETER_VECTOR_3_H_

#include "PulseSTD.h"
#include "IParameter.h"
#include "Vector3.h"

namespace Pulse
{
	class ParameterVector3 : public IParameter
	{
	public:

		ParameterVector3( void ) { m_vec = Vector3::ZERO_VECTOR; }

		ParameterVector3( ParameterVector3 &rhs );

		virtual ~ParameterVector3( void );

		virtual void SetData( void *pData );

		virtual void SetData( IParameter *pParam );

		void SetVector( const Vector3 *pVec ) { m_vec = *pVec; IncrementChangeValue(); }

		const Vector3 * GetVector( void ) const { return &m_vec; }

		virtual EParameter::Type GetType( void ) const { return EParameter::VECTOR3; }

	private:

		Vector3 m_vec;
	};
}

#endif /* _PSX_PARAMETER_VECTOR_3_H_ */