/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	Pulse.h
*
*	Description -	Main header include for the client application.
*
*	Comments	-	
*					
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	10/31/2009	-	Creation of this file
**************************************************************************************/

#ifndef _PSX_PULSE_H_
#define _PSX_PULSE_H_

#include "PulseSTD.h"

#include "MemoryManager.h"
#include "System.h"
#include "Engine.h"

#include "Allocators.h"
#include "ResourcePool.h"
#include "ResourceCache.h"
#include "ResourceFile.h"
#include "ResourceManager.h"

// Containers
#include "PTL.h"

// Math
#include "Math.h"
#include "Vector2.h"
#include "Vector3.h"
#include "Vector4.h"
#include "Matrix3x3.h"
#include "Matrix4x4.h"
#include "Plane.h"

// Utilities
#include "String.h"
#include "RandomTraverse.h"
#include "NonCopyable.h"
#include "Static.h"
#include "SmartPointer.h"
#include "String.h"
#include "Signature.h"
#include "FileIO.h"
#include "Clock.h"
#include "XMLParser.h"

// Systems
#include "ProcessManager.h"
#include "TaskScheduler.h"
#include "InputSystem.h"
//#include "Renderer.h"

#include "RenderTechnique.h"

// Application
#include "Application.h"
#include "WindowingSystem.h"
#include "Window.h"
#include "WindowView.h"
#include "Logic.h"
#include "View.h"

// Component System
#include "Actor.h"
#include "ComponentTransform.h"
#include "ComponentCamera.h"
#include "ComponentModelFilter.h"
#include "ComponentModelRenderer.h"
#include "ComponentReflection.h"
#include "ComponentLight.h"
#include "ComponentNativeScript.h"

#include "CSCameraControlFreeRoam.h"

// Temp
#include "Scene.h"
#include "GeometryElementInfo.h"
#include "GraphicsResourceManager.h"
#include "RenderEntryClearRenderBuffers.h"
#include "RenderEntryPresent.h"
#include "GlobalGraphicsStrings.h"

namespace Pulse
{
	 // We can add globals here...
}

#endif /* _PSX_PULSE_H_ */