/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	RenderEntryRasterizerState.h
*
*	Description -	Render entry set RasterizerState. Sets then binds the state.
*
*	Comments	-	
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	06/25/2013	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_RENDER_ENTRY_RASTERIZER_STATE_H_
#define _PSX_RENDER_ENTRY_RASTERIZER_STATE_H_

#include "PulseSTD.h"
#include "RenderEntry.h"
#include "RasterizerState.h"

namespace Pulse
{
	class RenderEntryRasterizerState : public RenderEntry
	{
	public:

		RenderEntryRasterizerState( RasterizerState *pState = PSX_NULL );

		virtual ~RenderEntryRasterizerState( void );

		void SetDepthStencilState( RasterizerState *pState ) { m_pState = pState; }

		//virtual void PreExecute( GraphicsPipeline *pPipeline ) { }

		virtual void Execute( GraphicsPipeline *pPipeline );

		//virtual void PostExecute( GraphicsPipeline *pPipeline ) { }

	private:

		RasterizerState *m_pState;

	};
}

#endif /* _PSX_RENDER_ENTRY_RASTERIZER_STATE_H_ */
