/**************************************************************************************
*
*	Copyright (C) 2009-2010 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	SignatureGenerator.h
*
*	Description -	Generates a unique signature(GUID).
*
*	Comments	-	Uses CoCreateGuid. According to MSDN:
*					The CoCreateGuid function calls the RPC function UuidCreate, which 
*					creates a GUID, a globally unique 128-bit integer. 
*					Use CoCreateGuid when you need an absolutely unique number that 
*					you will use as a persistent identifier in a distributed environment.
*					To a very high degree of certainty, this function returns a unique 
*					value  no other invocation, on the same or any other 
*					system (networked or not), should return the same value. 
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	09/07/2012		-	File creation
**************************************************************************************/
#ifndef _PSX_SIGNATURE_GENERATOR_H_
#define _PSX_SIGNATURE_GENERATOR_H_

#include "PulseSTD.h"
#include "Signature.h"

namespace Pulse
{
	class SignatureGenerator
	{
	public:

		static Signature GenerateSignature( void );
	};
}

#endif /* _PSX_SIGNATURE_GENERATOR_H_ */