/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	UnorderedAccessViewDesc.h
*
*	Description -	Unordered Access View Description
*
*	Comments	-
*
*	Modification History:
*			Name			   Date					Description
*			MrCodeSushi	-	07/28/2013	-	Creation of this file
**************************************************************************************/
#ifndef _PSX_UNORDERED_ACCESS_VIEW_DESC_H_
#define _PSX_UNORDERED_ACCESS_VIEW_DESC_H_

#include "PulseSTD.h"
#include "GraphicsTypes.h"

namespace Pulse
{
	class UnorderedAccessViewDesc
	{
	public:

		UnorderedAccessViewDesc( void );

		void Set( EGraphicsFormat::Type format, BufferInfoUAV *bufferInfo );

		void SetDefaults( void );

	public:

		EGraphicsFormat::Type		m_format;
		EGraphicsUAVDimension::Type m_viewDimension;

		union
		{
			BufferInfoUAV m_bufferInfo;
		};
	};
}

#endif /* _PSX_UNORDERED_ACCESS_VIEW_DESC_H_ */