/**************************************************************************************
*
*	Copyright (C) 2010 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	DepthStencilView.cpp
*
*	Comments	-	See DepthStencilView.h
*
**************************************************************************************/
#include "../Include/DepthStencilViewDesc.h"

namespace Pulse
{
	DepthStencilViewDesc::DepthStencilViewDesc( void )
	{
		SetDefaults();
	}

	void DepthStencilViewDesc::SetDefaults( void )
	{
		m_format = EGraphicsFormat::UNKNOWN;
		m_dimension = EGraphicsDSVDimension::UNKNOWN;
		m_readOnly = EDSVReadOnlyFlag::NONE;
	}

	void DepthStencilViewDesc::Set( EGraphicsFormat::Type format, EGraphicsDSVDimension::Type dimension, 
		EDSVReadOnlyFlag::Type readOnlyFlag, Tex2DInfoDSV *pTex2DInfo )
	{
		m_format = format;
		m_dimension = dimension;
		m_readOnly = readOnlyFlag;
		m_tex2D = *pTex2DInfo;
	}
}