/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ParameterBinderMatrixArray.cpp
*
*	Comments	-	See ParameterBinderMatrixArray.h
*
**************************************************************************************/
#include "../Include/ParameterBinderMatrixArray.h"
#include "../Include/ParameterMatrixArray.h"

namespace Pulse
{
	ParameterBinderMatrixArray::ParameterBinderMatrixArray( void )
		: m_arraySize( 0 ), m_pData( PSX_NULL )
	{
		
	}

	ParameterBinderMatrixArray::ParameterBinderMatrixArray( IParameter *pParam )
		: m_arraySize( 0 ), m_pData( PSX_NULL )
	{
		SetParameter( pParam );
	}
		
	SIZE_T ParameterBinderMatrixArray::GetNumMatrices( void )
	{
		if ( m_pParam->GetType() == EParameter::MATRIX_ARRAY )
			return ((ParameterMatrixArray*)m_pParam)->GetNumMatrices();
		else
			return 0;
	}

	void ParameterBinderMatrixArray::SetParameter( IParameter *pParam )
	{
		if ( pParam->GetType() == GetType() && 
			((ParameterMatrixArray*)pParam)->GetNumMatrices() == GetNumMatrices() )
		{
			m_pParam = pParam;
		}
		else
		{
			PSX_PushWarning( "Invalid Parameter type or number of matrices." );
		}
	}

	void ParameterBinderMatrixArray::BindValue( void )
	{
		if ( m_arraySize == m_pMatrixArrayParam->GetNumMatrices() )
			m_pMatrixArrayParam->SetMatrixArray( m_pData );
		else
			PSX_PushWarning( "Unequal matrix array size." );
	}

}