/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ParameterConstantBuffer.cpp
*
*	Comments	-	See ParameterConstantBuffer.h
*
**************************************************************************************/
#include "../Include/ParameterConstantBuffer.h"

namespace Pulse
{
	ParameterConstantBuffer::ParameterConstantBuffer( ParameterConstantBuffer &rhs )
		: IParameter( rhs ), m_pConstantBuffer( rhs.m_pConstantBuffer )
	{
	}

	ParameterConstantBuffer::~ParameterConstantBuffer( void )
	{
	}

	void ParameterConstantBuffer::SetData( void *pData )
	{
		m_pConstantBuffer = (ConstantBuffer*)pData;
		IncrementChangeValue();
	}

	void ParameterConstantBuffer::SetData( IParameter *pParam )
	{
		if ( pParam )
		{
			if ( pParam->GetType() == EParameter::CONSTANT_BUFFER )
			{
				m_pConstantBuffer = ((ParameterConstantBuffer*)pParam)->m_pConstantBuffer;
				IncrementChangeValue();
			}
		}
	}

}