/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ParameterVector3.cpp
*
*	Comments	-	See ParameterVector3.h
*
**************************************************************************************/
#include "../Include/ParameterVector3.h"

namespace Pulse
{
	ParameterVector3::ParameterVector3( ParameterVector3 &rhs )
		: IParameter( rhs )
	{
		m_vec = rhs.m_vec;
		IncrementChangeValue();
	}

	ParameterVector3::~ParameterVector3( void )
	{

	}

	void ParameterVector3::SetData( void *pData )
	{
		PSX_MemCopyPerByte( &m_vec, pData, sizeof(Vector3) );
		IncrementChangeValue();
	}


	void ParameterVector3::SetData( IParameter *pParam )
	{
		if ( pParam )
		{
			if ( pParam->GetType() == EParameter::VECTOR3 )
			{
				m_vec = ((ParameterVector3*)pParam)->m_vec;
				IncrementChangeValue();
			}
		}
	}
}