/**************************************************************************************
*
*	Copyright (C) 2010 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	ShaderResourceViewDesc.cpp
*
*	Comments	-	See ShaderResourceViewDesc.h
*
**************************************************************************************/
#include "../Include/ShaderResourceViewDesc.h"

namespace Pulse
{
	ShaderResourceViewDesc::ShaderResourceViewDesc( void )
	{
		SetDefaults();
	}

	void ShaderResourceViewDesc::Set( EGraphicsFormat::Type format, EGraphicsSRVDimension::Type dimension, 
			Tex2DInfoSRV *pTex2DInfo )
	{
		m_format = format;
		m_viewDimension = dimension;
		m_tex2DInfo = *pTex2DInfo;
	}

	void ShaderResourceViewDesc::Set( EGraphicsFormat::Type format, BufferInfoSRV *pBufferInfo )
	{
		m_format = format;
		m_viewDimension = EGraphicsSRVDimension::BUFFER;
		m_bufferInfo = *pBufferInfo;
	}

	void ShaderResourceViewDesc::SetDefaults( void )
	{
		m_format = EGraphicsFormat::UNKNOWN;
		m_viewDimension = EGraphicsSRVDimension::UNKNOWN;
	}

}