/**************************************************************************************
*
*	Copyright (C) 2009 - 2012 Brent Andrew O. Chua - See LICENSE.txt for more info.
*		
*	Filename	-	VertexElementSizes.cpp
*
*	Comments	-	See VertexElementSizes.h
*
**************************************************************************************/
#include "../Include/VertexElementSizes.h"
#include "../Include/VertexElementTypes.h"

namespace Pulse
{
	VertexElementSize_T VertexElementSizes::GetSize( EVertexElement::Type type )
	{
		switch( type )
		{
		case EVertexElement::POSITION:
			return sizeof( Vector3 );
		case EVertexElement::NORMAL:
			return sizeof( Vector3 );
		case EVertexElement::TEXTURE_DIFFUSE:
			return sizeof( Vector2 );
		case EVertexElement::TANGENT:
			return sizeof( Vector3 );
		default:
			{
				PSX_PushError( "Vertex element type not sypported yet." );
				return 0;
			}
		}
	}

}

